#!/bin/bash

# Ne koristim 'which' iako putanje nisu uvijek standardne
MYSQLREPORT="/usr/lib/zabbix-agent/mysqlreport"
MYSQLDAT=$(mktemp)
MYSQLUSER="zabbix_agentd"
MYSQLPASS="p4ssw0rdZabbi><"
# Zabbix_sender putanja ce ovisiti o paketu zabbix_agent !!
ZABBIX_SENDER="/usr/bin/zabbix_sender"
ZABBIX_CONF="/etc/zabbix/zabbix_agentd.conf"
 
function zsend { 
		$ZABBIX_SENDER -c $ZABBIX_CONF -k $1 -o $2 > /dev/null 2>&1
		}

$MYSQLREPORT --user $MYSQLUSER --password $MYSQLPASS --no-mycnf --outfile $MYSQLDAT --flush-status > /dev/null 2>&1

	zsend mysql.version `grep MySQL $MYSQLDAT|awk '{ print $2 }'|cut -d"-" -f1`
	zsend mysql.uptime `grep uptime $MYSQLDAT|awk '{ print $4":"$5 }'`
	zsend mysql.keysusedmaxpercent `grep -A1 Key $MYSQLDAT|awk 'NR==2 { print $7 }'`
	zsend mysql.keysusedcurrentpercent `grep -A2 Key $MYSQLDAT|awk 'NR==3 { print $4 }'`
	zsend mysql.keyswritehit `grep -A3 Key $MYSQLDAT|awk 'NR==4 { print $3 }'|sed 's/\%$//g'`
	zsend mysql.keysreadhit `grep -A4 Key $MYSQLDAT|awk 'NR==5 { print $3 }'|sed 's/\%$//g'`
	zsend mysql.questionstotal `grep -A1 Questions $MYSQLDAT|awk 'NR==2 { print $2 }'` #### sed -e 's/[k:M:G]$//g'
	zsend mysql.questionstotalpersec `grep -A1 Questions $MYSQLDAT|awk 'NR==2 { print $3 }'|sed 's/\/s$//g'`
	zsend mysql.questionsDMS `grep -A6 Questions $MYSQLDAT|grep DMS|awk '{ print $5 }'`
	zsend mysql.questionsCOM `grep -A6 Questions $MYSQLDAT|grep Com_|awk '{ print $4 }'`
	zsend mysql.questionsQCHits `grep -A6 Questions $MYSQLDAT|grep "QC Hits"|awk '{ print $5 }'`
	zsend mysql.questionsCOM_QUIT `grep -A6 Questions $MYSQLDAT|grep COM_QUIT|awk '{ print $4 }'`
	zsend mysql.questionsUnknown `grep -A6 Questions $MYSQLDAT|grep Unknown|awk '{ print $4 }'`
	zsend mysql.questionsSlow `grep -m1 Slow $MYSQLDAT|awk '{ print $6 }'`
	zsend mysql.questionsSlowDMS `grep -m1 Slow $MYSQLDAT|awk '{ print $8 }'`
	zsend mysql.QCmemmax `grep -A1 "Query Cache" $MYSQLDAT|awk 'NR==2 { print $5 }'`
	zsend mysql.QCmemused `grep -A1 "Query Cache" $MYSQLDAT|awk 'NR==2 { print $3 }'`
	zsend mysql.QCmemusedpercent `grep -A1 "Query Cache" $MYSQLDAT|awk 'NR==2 { print $7 }'`
	zsend mysql.QCblockfragment `grep "Block Fragmnt" $MYSQLDAT|awk '{ print $3 }'|sed 's/\%$//g'`
	zsend mysql.QCHits `grep -A7 "Query Cache" $MYSQLDAT|grep Hits|awk '{ print $2 }'`
	zsend mysql.QCInserts `grep -A7 "Query Cache" $MYSQLDAT|grep Inserts|awk '{ print $2 }'`
	zsend mysql.QCInsertPruneRatio `grep -A7 "Query Cache" $MYSQLDAT|grep Insrt:Prune|awk '{ print $2 }'`
	zsend mysql.QCHitInsertRatio `grep -A7 "Query Cache" $MYSQLDAT|grep Hit:Insert|awk '{ print $2 }'`
	zsend mysql.tablestotal `grep -A1 Tables $MYSQLDAT|awk 'NR==2 { print $4 }'`
	zsend mysql.tablesopen `grep -A1 Tables $MYSQLDAT|awk 'NR==2 { print $2 }'`
	zsend mysql.tablesopenpercent `grep -A1 Tables $MYSQLDAT|awk 'NR==2 { print $6 }'`
	zsend mysql.tablelockswaited `grep -A1 "Table Locks" $MYSQLDAT|awk 'NR==2 { print $2 }'`
	zsend mysql.tablelockswaitedpercent `grep -A1 "Table Locks" $MYSQLDAT|awk 'NR==2 { print $5 }'`
	zsend mysql.tablelocksimmediate `grep -A2 "Table Locks" $MYSQLDAT|awk 'NR==3 { print $2 }'`
	zsend mysql.connectionsmax `grep -A1 Connections $MYSQLDAT|awk 'NR==2 { print $5 }'`
	zsend mysql.connectionstotalpersec `grep -A2 Connections $MYSQLDAT|awk 'NR==3 { print $3 }'|sed 's/\/s$//g'`
	zsend mysql.connectionsusedmax `grep -A1 Connections $MYSQLDAT|awk 'NR==2 { print $3 }'`
	zsend mysql.connectionsusedmaxpercent `grep -A2 Connections $MYSQLDAT|awk 'NR==2 { print $7 }'`
	zsend mysql.tempdisktable `grep -A1 "Created Temp" $MYSQLDAT|awk 'NR==2 { print $3 }'|sed -e 's/\.//' -e 's/k/0/' -e 's/M/0000/' -e 's/G/0000000/' -e 's/T/0000000000/' -e 's/P/0000000000000/'`
	zsend mysql.temptable `grep -A2 "Created Temp" $MYSQLDAT|awk 'NR==3 { print $2 }'|sed -e 's/\.//' -e 's/k/0/' -e 's/M/0000/' -e 's/G/0000000/' -e 's/T/0000000000/' -e 's/P/0000000000000/'`
	zsend mysql.tempfile `grep -A3 "Created Temp" $MYSQLDAT|awk 'NR==4 { print $2 }'|sed -e 's/\.//' -e 's/k/0/' -e 's/M/0000/' -e 's/G/0000000/' -e 's/T/0000000000/' -e 's/P/0000000000000/'`
	zsend mysql.threadstotal `grep -A1 Threads $MYSQLDAT|awk 'NR==2 { print $4 }'`
	zsend mysql.threadsrunning `grep -A1 Threads $MYSQLDAT|awk 'NR==2 { print $2 }'`
	zsend mysql.threadscached `grep -A2 Threads $MYSQLDAT|awk 'NR==3 { print $2 }'`
	zsend mysql.threadscachehit `grep -A2 Threads $MYSQLDAT|awk 'NR==3 { print $6 }'`
	zsend mysql.bytessent `grep -A1 Bytes $MYSQLDAT|awk 'NR==2 { print $2 }'|sed -e 's/\.//' -e 's/k/0/' -e 's/M/0000/' -e 's/G/0000000/' -e 's/T/0000000000/' -e 's/P/0000000000000/'`
	zsend mysql.bytesreceived `grep -A2 Bytes $MYSQLDAT|awk 'NR==3 { print $2 }'|sed -e 's/\.//' -e 's/k/0/' -e 's/M/0000/' -e 's/G/0000000/' -e 's/T/0000000000/' -e 's/P/0000000000000/'`

rm -f $MYSQLDAT
echo "1"
